apiVersion: keycloak.org/v1alpha1
kind: KeycloakClient
metadata:
  name: grafana
  namespace: keycloak
  labels:
    app: keycloak
spec:
  realmSelector:
    matchLabels:
      app: keycloak
  client:
    # Secret: a secret key must be provided in this manifest.
    secret: "{{KEYCLOAK_GRAFANA_CLIENT_SECRET}}"
    clientId: grafana
    name: "Kumori Grafana"
    description: "Kumori Cluster Grafana Service users management"
    baseUrl: "https://grafana-{{RELEASE_NAME}}.{{REFERENCE_DOMAIN}}"
    surrogateAuthRequired: false
    enabled: true
    clientAuthenticatorType: "client-secret"
    redirectUris:
    - "https://grafana-{{RELEASE_NAME}}.{{REFERENCE_DOMAIN}}/login/generic_oauth"
    - "https://grafana-{{RELEASE_NAME}}.{{REFERENCE_DOMAIN}}/*"
    - "http://localhost"
    webOrigins:
    - "https://grafana-{{RELEASE_NAME}}.{{REFERENCE_DOMAIN}}"
    - "https://grafana-{{RELEASE_NAME}}.{{REFERENCE_DOMAIN}}/login"
    notBefore: 0
    bearerOnly: false
    consentRequired: false
    standardFlowEnabled: true
    implicitFlowEnabled: true
    directAccessGrantsEnabled: true
    serviceAccountsEnabled: false
    publicClient: false
    frontchannelLogout: false
    protocol: "openid-connect"
    attributes: 
      "saml.assertion.signature" : "false"
      "access.token.lifespan" : "604800"
      "saml.force.post.binding" : "false"
      "saml.multivalued.roles" : "false"
      "saml.encrypt" : "false"
      "saml.server.signature" : "false"
      "saml.server.signature.keyinfo.ext" : "false"
      "exclude.session.state.from.auth.response" : "false"
      "saml_force_name_id_format" : "false"
      "saml.client.signature" : "false"
      "tls.client.certificate.bound.access.tokens" : "false"
      "saml.authnstatement" : "false"
      "display.on.consent.screen" : "false"
      "saml.onetimeuse.condition" : "false"
    fullScopeAllowed: true
    nodeReRegistrationTimeout: -1
    protocolMappers:
    - name: "groups"
      protocol: "openid-connect"
      protocolMapper: "oidc-usermodel-realm-role-mapper"
      consentRequired: false
      config: 
        "multivalued" : "true"
        "userinfo.token.claim" : "true"
        "user.attribute" : "foo"
        "id.token.claim" : "true"
        "access.token.claim" : "true"
        "claim.name" : "groups"
        "jsonType.label" : "String"
    - name: "client/groups"
      protocol: "openid-connect"
      protocolMapper: "oidc-usermodel-client-role-mapper"
      consentRequired: false
      config: 
        "multivalued" : "true"
        "userinfo.token.claim" : "true"
        "id.token.claim" : "true"
        "access.token.claim" : "true"
        "claim.name" : "client-groups"
        "jsonType.label" : "String"
        "usermodel.clientRoleMapping.clientId" : "grafana"
    defaultClientScopes:
    - web-origins
    - role_list
    - profile
    - roles
    - email
    optionalClientScopes:
    - address
    - phone
    - offline_access
    - microprofile-jwt
  roles:
  - name: grafana-admin
    composite: false
    clientRole: true
    attributes: { }
  - name: grafana-viewer
    composite: false
    clientRole: true
    attributes: { }
